/*
* This file is part of the acnchess package
* Copyright (C) <2008>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE acccli.h
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2009/08/12 11:13:04 Alf*/

#ifndef _ACC_CLI_H_
#define _ACC_CLI_H_

#include "tport.h"
#include "packet.h"
#include "acnkern.h"

typedef struct
{
  int status;

  tport_t *tport;

  char buffer[0x100];

  packet_t packet[1];

} acccli_t;

acccli_t *acccli_new (const char *, unsigned short);

acccli_t *acccli_new_with_tport (tport_t *);

void acccli_delete (acccli_t *);

/*
 * get user list in a proxy
 * */
int acccli_get_userlist (acccli_t *, char *, int);

/*
 * get a user's detail from a proxy
 * */
int acccli_get_userdetail (acccli_t *, char *, int);

/*
 * request a fight
 * with parter id
 * */
int acccli_fight_request (acccli_t *, const char *);

/*
 * start fight
 * */
int acccli_fight_start (acccli_t *);

/*
 * hui a move
 * */
int acccli_fight_hui (acccli_t *);

/*
 * quit fight
 * */
int acccli_fight_quit (acccli_t *);

/*
 * move
 * */
int acccli_fight_move (acccli_t *, struct xq_move *);

/*
 * get other move
 * */
struct xq_move *acccli_get_move (acccli_t *);

#endif
