/*
* This file is part of the acnchess package
* Copyright (C) <2008>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE accecco.c
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2011/05/18 13:40:44 Alf*/

#include "accecco.h"

#ifdef WIN32
#include <windows.h>
#else
#include <dlfcn.h>
#endif

int
ecco_init ()
{
#ifdef WIN32
  HMODULE hModule = LoadLibrary("ECCO.DLL");

  EccoVersion = (const char * (*) (void)) GetProcAddress (hModule, "_EccoVersion@0");
  EccoInitOpenVar = (void (*) (int)) GetProcAddress(hModule, "_EccoInitOpenVar@4");
  EccoIndex = (long (*) (const char *)) GetProcAddress(hModule, "_EccoIndex@4");
  EccoOpening = (const char * (*) (long)) GetProcAddress(hModule, "_EccoOpening@4");
  EccoVariation = (const char * (*) (long)) GetProcAddress(hModule, "_EccoVariation@4");
#else
  void *hModule = dlopen("libecco.so", RTLD_LAZY);

  EccoVersion = (const char *(*)(void)) dlsym (hModule, "EccoVersion");
  EccoInitOpenVar = (void (*)(int)) dlsym (hModule, "EccoInitOpenVar");
  EccoIndex = (long (*)(const char *)) dlsym (hModule, "EccoIndex");
  EccoOpening = (const char *(*)(long)) dlsym (hModule, "EccoOpening");
  EccoVariation = (const char *(*)(long)) dlsym (hModule, "EccoVariation");
#endif

  return 0;
}

void
ecco_destroy ()
{
}

