/*
* This file is part of the acnchess package
* Copyright (C) <2008>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE accset.h
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2009/08/11 08:59:37 Alf*/

#ifndef _ACC_SET_H_
#define _ACC_SET_H_

#include "iniparser.h"

#include <gtk/gtk.h>

typedef struct
{
  GtkWidget *widget;

  char *file;

  dictionary *dic;

  int pc_level;

  char *pc_engine;

  /* NETWORK sets */
  int net_conn_timeout;
  GtkWidget *wid_net_conn_timeout;

  int net_read_timeout;
  GtkWidget *wid_net_read_timeout;

  int net_ref_user;
  GtkWidget *wid_net_ref_user;

  int net_max_users;
  GtkWidget *wid_net_max_users;

  unsigned long net_ip;
  GtkWidget *wid_net_ip;

  int net_tcp;
  GtkWidget *wid_net_tcp;

  int net_udp;
  GtkWidget *wid_net_udp;
} accset_t;

accset_t *accset_new (const char *);

#define accset_widget(x)         ((x)->widget)

void accset_delete (accset_t *);

extern accset_t *g_set;

#endif
