/*
* This file is part of the acnchess package
* Copyright (C) <2008>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE accus.h
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2009/08/13 10:11:03 Alf*/

#ifndef _ACC_US_H_
#define _ACC_US_H_

#include "dht.h"
#include "proxysrv.h"

#include <gtk/gtk.h>

struct proxy_node
{
  unsigned long ip;
  unsigned short port;
  LIST_ENTRY (proxy_node) entries;
};

typedef struct
{
  GtkWidget *widget;

  GtkListStore *musrs;
  GtkTreeSelection *usel;
  GtkTreeIter uitr[1];

  GtkListStore *mfriends;
  GtkTreeSelection *fsel;
  GtkTreeIter fitr[1];

  proxy_srv *proxysrv;
  GThread *proxysrvthread;

  dht_t *dht;
  GThread *dhtthread;

  gint refuser;

  LIST_HEAD (proxylist, proxy_node) proxy_list[1];

} accus_t;

#define accus_widget(x)         ((x)->widget)

accus_t *accus_new ();

void accus_delete (accus_t *);

#endif
