/*
* This file is part of the acnchess package
* Copyright (C) <2008>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE acnguykerenl.h
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2009/08/01 00:39:49 Alf*/

#ifndef _ACNGUY_KERNEL_H_
#define _ACNGUY_KERNEL_H_

#include "qipu.h"

typedef struct acnkern_s acnkern_t;

typedef int (*acnkern_callback) (void *);
typedef void * acnkern_callback_arg;

acnkern_t *acnkern_new (acnkern_callback, acnkern_callback_arg);

void acnkern_set_depth (acnkern_t *, int);

void acnkern_set_callback_count (acnkern_t *, int);

void acnkern_delete (acnkern_t *);

int acnkern_set_pan (acnkern_t *, char [10][9]);

int acnkern_set_move (acnkern_t *, struct xq_move *);

int acnkern_set_banmove (acnkern_t *, struct xq_move *);

struct xq_move *acnkern_go (acnkern_t *, int);

#endif
