/*
* This file is part of the acnchess package
* Copyright (C) <2008>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE packet.h
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2009/08/12 13:11:58 Alf*/

#ifndef _ACC_PACKET_H_
#define _ACC_PACKET_H_

#ifndef ELEM_MAX
#define ELEM_MAX        0x200
#endif

#ifndef ACP_VERSION
#define ACP_VERSION     10
#endif

enum
{
  ACP_REG,			/* login */
  ACP_REG_OK,
  ACP_REG_ERROR,

  ACP_PING,			/* test alive */
  ACP_PINGRES,			/* reponse alive */

  ACP_GET_USERLIST,		/* get user list  */
  ACP_GET_USERLIST_OK,
  ACP_GET_USERLIST_ERROR,

  ACP_GET_USERDETAIL,		/* get user detail */
  ACP_GET_USERDETAIL_OK,
  ACP_GET_USERDETAIL_ERROR,

  ACP_ACTION_REQUEST,		/* request a pan */
  ACP_ACTION_RESPONSE,		/* response a pan */

  ACP_ACTION_MOVE,		/* move a zi */
  ACP_ACTION_START,		/* start */
  ACP_ACTION_QUIT,		/* quit */
  ACP_ACTION_ROLLBACK,		/* hui qi */
  ACP_ACTION_ERROR,
};

typedef struct packet_elem packet_elem;

struct packet_elem
{
  unsigned short type;
  unsigned short length;
  char data[ELEM_MAX];
  packet_elem *next;
};

typedef struct
{
  unsigned short type;
  unsigned short version;
  packet_elem *elem;
} packet_t;

int packet_encode (packet_t *, char *, unsigned short);

int packet_decode (const char *, unsigned short, packet_t *);

void packet_free (packet_t *);

packet_elem *packet_elem_new (unsigned short, int, const char *);

#endif
