/*
* This file is part of the acnchess package
* Copyright (C) <2008>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE proxysrv.h
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2009/08/27 10:24:24 Alf*/

#ifndef _ACC_PS_H_
#define _ACC_PS_H_

#ifndef ACC_PROXY_SERVER_TOKEN
#define ACC_PROXY_SERVER_TOKEN  "0817-acc-proxy-srv"
#endif

typedef struct
{
  /* client socket */
  int fd;

  /* client id and pass */
  char *id;
  char *pass;

  /* client status */
  int status;

  /* network order address */
  unsigned long ip;
  unsigned short port;
} dclient_t;

typedef struct
{
  int fd;

  dclient_t clients[32];
  int max, cur;

  int running;
} proxy_srv;

proxy_srv *proxysrv_new (int, unsigned short);

void proxysrv_delete (proxy_srv *);

int proxysrv_start ();

void proxysrv_stop ();

#endif
