/*
* This file is part of the acnchess package
* Copyright (C) <2008>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE qipu.h
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2009/08/12 11:13:04 Alf*/

#ifndef _ACC_QIPU_H_
#define _ACC_QIPU_H_

#include "fen.h"

#include <glib.h>

#ifdef WIN32
#define ssize_t int
#endif
#include <stdlib.h>

struct xq_move
{
  int dead;     /* be killed one */

  int isred;

  int fromx, fromy;

  int tox, toy;
};

typedef struct qipu_s qipu_t;

/*
 * qiqu struct functions
 * */
qipu_t * qipu_new ();

qipu_t * qipu_new_from_file (const char *);

int qipu_load (qipu_t *, const char *);

int qipu_save (qipu_t *, const char *);

void qipu_destroy (qipu_t *);

/*
 * qipu move functions
 * */
int qipu_get_fen (qipu_t *, fen_t *);

int qipu_set_fen (qipu_t *, fen_t *);

const char * qipu_get_info (qipu_t *, const char *);

int qipu_set_info (qipu_t *, const char *, const char *);

int desc_to_move (char [10][9], const char *, struct xq_move *);

ssize_t move_to_desc (char [10][9], struct xq_move *, char *, size_t);

int qipu_append_move (qipu_t *, struct xq_move *);

int qipu_move_first (qipu_t *, struct xq_move *);

int qipu_move_next (qipu_t *, const struct xq_move *, struct xq_move *);

#endif
