/*
* This file is part of the acnchess package
* Copyright (C) <2008>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE session.h
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2009/09/04 23:48:17 Alf*/

#ifndef _ACC_SESSION_H_
#define _ACC_SESSION_H_

#include "acnkern.h"
#include "acccli.h"
#include "qipu.h"
#include "fen.h"

typedef struct session_s session_t;

session_t *session_new (const char *);

const char *session_desc (session_t *);

void session_delete (session_t *);

struct xq_move *session_get_move (session_t *, fen_t *, GList *, int, int);

int session_start (session_t *);

int session_hui (session_t *);

int session_stop (session_t *);

#endif
