/*
* This file is part of the acnchess package
* Copyright (C) <2010>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE ucci.h
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2011/07/13 10:10:21 Alf*/

#ifndef _ACN_UCCI_H_
#define _ACN_UCCI_H_

#include <stdlib.h>

#define UCCI_CMD_LEN            0x10
#define UCCI_CMD_ARG_LEN        0x200
#define UCCI_CMD_ARG_MAX        0x100

#define _CMD(S)              UCCI_CMD_##S
enum ucci_cmd
{
  _CMD(UCCI),
  _CMD(ID),
  _CMD(OPTION),
  _CMD(UCCIOK),
  _CMD(ISREADY),
  _CMD(READYOK),
  _CMD(SETOPTION),
  _CMD(POSITION),
  _CMD(BANMOVES),
  _CMD(GO),
  _CMD(INFO),
  _CMD(PONDERHIT),
  _CMD(STOP),
  _CMD(BESTMOVE),
  _CMD(NOBESTMOVE),
  _CMD(PROBE),
  _CMD(POPHASH),
  _CMD(QUIT),
  _CMD(BYE),
};
#undef _CMD

typedef struct
{
  int cmd;
  char args[UCCI_CMD_ARG_MAX][UCCI_CMD_ARG_LEN];
  size_t arg_count;
} ucci_cmd;

int ucci_cmd_to_string (ucci_cmd *cmd, char *out, size_t out_len);

int ucci_cmd_from_string (ucci_cmd *cmd, const char *in);

#endif
