/*
* This file is part of the acnchess package
* Copyright (C) <2008>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE util.h
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2009/07/29 14:20:37 Alf*/

#ifndef _ACC_UTIL_H_
#define _ACC_UTIL_H_

#include <limits.h>
#include <libintl.h>
#include <gtk/gtk.h>

#define _(S)            gettext (S)

#ifdef WIN32
#define random          rand

#define __func__        __FUNCTION__
#define inline          __inline

#ifndef PATH_MAX
#define PATH_MAX	    0x200
#endif

#endif

char *acc_realpath (const char *);

#define HTTP_PORT    80
#define HTTPS_PORT  443

enum
{
  HTTP,
  HTTPS
};

typedef struct
{
  int type;
  unsigned long ip;		/* network order */
  char addr[0x10];		/* host order */
  unsigned short port;		/* host order */
  char host[PATH_MAX];
  char username[PATH_MAX];
  char password[PATH_MAX];
  char doc[PATH_MAX];
} acc_url;

/* parse a string to struct alit_url
 * return 0 if ok
 * return -1 if error */
int str2url (const char *, acc_url *);

void gtk_add_popup_menu (GtkWidget *, GtkMenu *);

void gtk_menu_add_item (GtkWidget *, const char *, void (*)(gpointer),
                        gpointer);

#endif
