/*
* This file is part of the acnchess package
* Copyright (C) <2010>  <Alf>
*
* Contact: Alf <naihe2010@126.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
*/
/* @CFILE zgxq.h
*
*  Author: Alf <naihe2010@126.com>
*/
/* @date Created: 2011/07/14 15:07:40 Alf*/

#ifndef _ACN_ZGXQ_H_
#define _ACN_ZGXQ_H_

enum
{
  NONE = 0,
  R_SHUAI,
  B_SHUAI,
  R_SHI,
  B_SHI,
  R_XIANG,
  B_XIANG,
  R_MA,
  B_MA,
  R_JU,
  B_JU,
  R_PAO,
  B_PAO,
  R_BING,
  B_BING,
};

#define IS_BLACK(x)     (x && (!(x % 2)))
#define IS_RED(x)       (x % 2)
#define IS_SAME(x,y)    ((IS_BLACK(x) && IS_BLACK(y)) || (IS_RED(x) && IS_RED(y)))

#define pan_move(p,x,y,tx,ty) do {              \
    p[(ty)][(tx)] = p[(y)][(x)];                \
    p[(y)][(x)] = 0;                            \
} while (0)

int zgxq_move_is_valid (char pan[10][9], int, int, int, int);

int zgxq_is_over (char pan[10][9]);

void output_pan (char pan[10][9]);

extern char default_pan[10][9];

extern char *number_str[];

extern char *number_b_str[];

extern char *zi_chinese[];

extern char *number_chinese_str[];

#endif
